#ifndef __bbqueue_h__
#define __bbqueue_h__

class BroadbandQueue {
protected:
  const static int MAX_ENTRIES = 1000;

  long long lastArrival;
  long long currentBurstRequestTime;
  long long currentBurstXmitTime;
  long long nextMediumFree;
  int currentBurstSizeBytes;
  int currentBurstID;
  
  /* queue[0] will be transmitted next */
  struct {
    int id;
    int sizeBytes;
    long long txmit;
    int burstID;
    bool inFlight;
  } queue[MAX_ENTRIES];
  int numEntries;

  void getQueueSizeAt(long long now, int *packets, int *bytes);
  
public:
  int delayMicros;
  int capacityPackets;
  int capacityBytes;
  int lineRateBps;

  BroadbandQueue();
  bool append(int id, int size, long long now);
  void reset();
  long long nextEvent();
  int getNextPacket(long long now);
  void dump(FILE *stream);
};

#endif /* defined(__bbqueue_h__) */
